"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractSelector = exports.proxyOf = exports.propertyOf = void 0;
exports.propertyOf = new Proxy({}, { get: function (_, p) { return p; } });
var proxyOf = function (self) {
    return new Proxy(self, { get: function (t, p) { return t.provide(p); } });
};
exports.proxyOf = proxyOf;
function extractSelector(options) {
    switch (typeof options) {
        case 'function':
            return options(exports.propertyOf);
        case 'symbol':
        case 'string':
            return options;
        default:
            throw new Error("extractSelector could not match anything");
    }
}
exports.extractSelector = extractSelector;
