import { ILifetime } from '../Lifetime';
import { Factory, IServiceCollection, Key } from './IServiceCollection';
export declare type MockSetup<E> = {
    [key in keyof E]?: Partial<E[key]> | Factory<Partial<E[key]>, E>;
};
export declare function proxyLifetimes<E>(services: IServiceCollection<E>, mock: MockSetup<E>): import("../ServiceProvider").IServiceProvider<E>;
export declare function proxyLifetime<E>(lifetime: ILifetime<unknown, E>, mock: MockSetup<E>[Key<E>] | undefined): ILifetime<unknown, E>;
export declare function proxyValue<T extends object>(name: string, obj: Partial<T>): T;
