import { Key, Selector } from './ServiceCollection';
import { IServiceProvider } from './ServiceProvider';
export declare type PropertyOf<E> = Required<{
    [key in keyof E]: key & Key<E>;
}>;
export declare const propertyOf: any;
export declare const proxyOf: <E>(self: IServiceProvider<E>) => E;
export declare function extractSelector<T, E>(options: Selector<T, E>): Key<E>;
